/***************************************************************************
                          clha.cpp  -  description
                             -------------------
    begin                : Sat Dec 2 2000
    copyright            : (C) 2000 by Eric Coquelle
    email                : coquelle@caramail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "clha.h"
#include <kdebug.h>
#include <qdir.h>

CLha::CLha(){
	CArchive();

	connect(&processread,SIGNAL(receivedStdout(KProcess*, char*, int)),this,SLOT(haveSdtOut(KProcess*,char*,int)));
	connect(&processread,SIGNAL(processExited (KProcess*)),this,SLOT(endProcess(KProcess*)));
	connect(&processextract,SIGNAL(receivedStdout(KProcess*, char*, int)),this,SLOT(haveSdtOutExtract(KProcess*,char*,int)));
	connect(&processextract,SIGNAL(processExited (KProcess*)),this,SLOT(endProcess(KProcess*)));

	list->setColumnText(4, i18n("Owner"));
	list->setColumnText(5, i18n("Permissions"));
}

CLha::~CLha(){
}

/** this method will launch the right compressor
to list the file contents
It will then launch the right method to display
the content in the listview */
void CLha::displayArchiveContent(){
	FILE *flot;

	initializeReadingArchive();

	processread << "lha";
	processread << "l" << archiveName;

	if(readArchiveWithStream)
	{
		processread.demarrer(&flot,KProcess::AllOutput);
		displayLhaArchiveContent(flot);
		displayMessageArchiveSize();
		led->setColor(KLed::green);
	}
	else
	{
		m_buffer[0]='\0';
		processread.start(KProcess::NotifyOnExit, KProcess::AllOutput);
	}
}

/** display in a listview the content of the current
lha archive. This method examines the stdout of
unarj to sort useful infos for the listview */
void CLha::displayLhaArchiveContent( FILE* flot ){
	CListViewItem* elementListe;
	char tampon[5000];
	char permission[30];
	char proprietaire[256];
	char crc[20];
	char taille[30];
	char date[12];
	char heure[7];
	char snom[5000];
	QString path;
	QString nom;
	QString message;
	int i;

	do
		fgets( tampon, 5000, flot );
	while( !feof(flot) && (strstr( tampon, "--------------------" )==NULL));
	fgets( tampon, 5000, flot );
	while( !feof(flot) && (strstr( tampon, "----" )==NULL))
	{
		sscanf(tampon, " %[MSDOdrwxst-] %[0-9a-zA-Z/] %[0-9] %[*.0-9%] %[a-zA-Z] %[0-9-] %[0-9:] %[^\n]", permission, proprietaire, taille, crc, crc, date, heure, snom );

		nom=snom;
		nom=" "+nom;
		i=nom.findRev('/');
		if(i!=-1)
		{
			path=nom.left(i+1);
		 	nom=nom.remove(0,i+1);
		if(nom=="")
			nom="..";
		}
		else
			path="";

		elementListe=new CListViewItem(list,nom,taille,heure,date,proprietaire,permission,path);
		definitIcone(nom, permission, elementListe);
		elementListe->widthChanged();
		fgets( tampon, 5000, flot );
	}
	fclose( flot );
}

/*Overloaded method*/
void CLha::displayLhaArchiveContent( const char* ligne){
	CListViewItem* elementListe;
	char permission[30];
	char proprietaire[256];
	char crc[20];
	char taille[30];
	char date[12];
	char heure[7];
	char snom[5000];
	QString path;
	QString nom;
	QString message;
	int i;

		sscanf(ligne, " %[drwxst-] %[0-9a-zA-Z/] %[0-9] %[*.0-9%] %[a-zA-Z] %[0-9-] %[0-9:] %[^\n]", permission, proprietaire, taille, crc, crc, date, heure, snom );

		nom=snom;
		nom=" "+nom;
		i=nom.findRev('/');
		if(i!=-1)
		{
			path=nom.left(i+1);
		 	nom=nom.remove(0,i+1);
		if(nom=="")
			nom="..";
		}
		else
			path="";

		elementListe=new CListViewItem(list,nom,taille,heure,date,proprietaire,permission,path);
		definitIcone(nom, permission, elementListe);
		elementListe->widthChanged();
}

/** we recive some informations through the standard
output of the process */
void CLha::haveSdtOut(KProcess *, char *buffer, int length){
	//Has user canceled current action ?
	if(stopreadprocess)
		return;

	// This section is here only for testing. It has been taken from ark:
	//1997-1999: Rob Palmbos palm9744@kettering.edu
	//2000: Corel Corporation (author: Emily Ezust, emilye@corel.com)
	//and adapted to karchiveur
	int passage;
  char c = buffer[length];
  buffer[length] = '\0';

//  m_settings->appendShellOutputData( buffer );

  char line[1024] = "";
  char *tmpl = line;
  char *tmpb;

  displayMessage(i18n("Running compressor..."));


  //We copy m_buffer to tmpl
  for( tmpb = m_buffer; *tmpb != '\0'; tmpl++, tmpb++ )
    *tmpl = *tmpb;

  //We copy the fisrt string of buffer (till \n) to tmpl
  for( tmpb = buffer; *tmpb != '\n'; tmpl++, tmpb++ )
    *tmpl = *tmpb;

  tmpb++;
  *tmpl = '\0';

  if( *tmpb == '\0' )
    m_buffer[0]='\0';

	if((strncmp(line," PERMSSN",8)!=0)&&(strncmp(line,"----------",10)!=0))
  	displayLhaArchiveContent( line );

  bool stop = (*tmpb == '\0');
  passage=0;

  while( !stop)
  {
      tmpl = line; *tmpl = '\0';

      for(; (*tmpb!='\n') && (*tmpb!='\0'); tmpl++, tmpb++)
				*tmpl = *tmpb;

      if( *tmpb == '\n' )
			{
			  *tmpl = '\n';
			  tmpl++;
			  *tmpl = '\0';
			  tmpb++;

	  	if((passage<1)&&(strncmp(line," PERMSSN",8)!=0)&&(strncmp(line,"----------",10)!=0))
	  		displayLhaArchiveContent( line );
  		else
  			passage++;
			}
      else if (*tmpb == '\0' )
			{
	  		*tmpl = '\0';
			  strcpy( m_buffer, line );
	  		stop = true;
			}
    }
  buffer[length] = c;
}

/** we recive some informations through the standard
	* output of the process */
void CLha::haveSdtOutExtract(KProcess *, char *buffer, int length){
	QString inter;
	int i=0;

	inter=buffer;
	inter=inter.left(length);

	while((i=inter.find('\n',i+1))!=-1){
		progressbar->setProgress(progressbar->progress()+1);
	}
}

/** The current process ended */
void CLha::endProcess(KProcess*){
  kdDebug()<<("Process ENDED\n");
	led->setColor(QColor("green"));
	displayMessageArchiveSize();
	progressbar->reset();

	emit(archiveReadEnded());
}

/** Upon the kind of archive, choose the right
	*uncompressor and extract all or some files
	*@toutextraire = 9: extract to karchiveur's temp directory (for viewing)
	*@toutextraire = 1: extract all selected files
	*/
void CLha::extractArchive(QString &extractpath, int extractall, QString & filetoextract){
 	int k,l;
 	QString directoryOption;
 	QString nomextrait;
 	QString fichiersaextraire;
 	QListViewItem *vi;

	directoryOption="";
	fichiersaextraire="";
	counter=0;
	progressbar->reset();
	progressbar->setTotalSteps(list->childCount());

	processextract.clearArguments();
	processextract << "lha";

	directoryOption="-xw";
	directoryOption+=extractpath;
	processextract << directoryOption;
	if(!overwrite)
		processextract << "-f";

 	processextract << archiveName;

 	//We will extract all selected files
 	if(extractall==1)
 	{
 		l=0;
 		vi=list->firstChild();
 		for(k=0;k<list->childCount();k++)
 		{
 			if((vi->isSelected())&&(strcmp(vi->text(0),"..")!=0))
 			{
 				fichiersaextraire+=vi->text(6);
 				fichiersaextraire+=vi->text(0);
 				fichiersaextraire=fichiersaextraire.right(fichiersaextraire.length()-1);
 				processextract << fichiersaextraire;
 				fichiersaextraire="";
 				l++;
 			}
 			vi=vi->nextSibling();
 		}
 		progressbar->setTotalSteps(l);
 	}
 	//We want to view (and so extract) only one file. So we just add this file to the tar or unzip
 	//command. For gzip and bzip2 files, in any case, we extract one and only one file, so I put
 	//it apart
 	else if(extractall==EXTRACTONE_ANDBLOCK)
 	{
 		processextract << filetoextract;
 		if(processextract.start(KProcess::Block)==FALSE)
		  kdDebug()<<("\n*PB PROCESS*\n");
 	}

 	//We extract through the Stdout to have a progress indicator
 	if(extractall!=EXTRACTONE_ANDBLOCK)
 	{
 		if(processextract.start(KProcess::NotifyOnExit,KProcess::Stdout)==FALSE)
		  kdDebug()<<("\n*PB PROCESS*\n");
 	}
 	counter=0;
}

/** delete @param filestodelete from current archive */
void CLha::removeFilesFromArchive (QStrList filestodelete){
  kdDebug()<<("In:enleveFichiersArchiveLha\n");
 	processread.clearArguments();
 	processread << "lha" << "-d";
 	processread << archiveName;
  for (QString f = filestodelete.first(); f; f = filestodelete.next())
  {
    kdDebug()<<QString("Will remove:%1*").arg(f)<<endl;
    processread << f;
  }
  processread.start(KProcess::Block);
  kdDebug()<<("Ok:enleveFichiersArchiveTar\n");
}

/** Add some files to the archive
@param filestoadd : list of files to add
@param removeoriginalfiles : remove or not those files from disk
@param action : 0=mode append and replace files, 1=mode update files
@param relativepath : if !NULL, include only filenames, without their base path */
void CLha::addFilesToArchive( QStrList filestoadd, bool removeoriginalfiles, int action, const char* relativepath){
	QString s;

	if(relativepath!=NULL)
		QDir::setCurrent(relativepath);

	processread.clearArguments();
	processread << "lha";
	if(removeoriginalfiles)
		processread << "-d";
	/* Not supported by lha
	if(recursivemode)
		processread << "-r";*/
	switch(action)
	{
		case 1:
			//Mode update
			processread << "-u";
			break;
		default:
			processread << "-a";
			break;
	}

	processread << archiveName;
	for (QString f = filestoadd.first(); f; f = filestoadd.next())
	{
	  s=f;
	  if(s.right(1)=="/")
	    s.truncate(s.length()-1);
	  if(s.find("file:")==0)
	    s.remove(0,5);
	  kdDebug()<<QString("AjArchLha:%1*in:%2*").arg(s).arg(archiveName)<<endl;
  	processread << s;
	}
	processread.start(KProcess::Block);
}

/** Create a lha archive
@param  nameofarchive: the name of the zip archive
@param param: list of files to add
@param relativepath: include only filenames, without their path */
void CLha::createArchive(QString nameofarchive, QStrList filestoadd, const char* relativepath) {
	QString str;

	archiveName=nameofarchive;
	kdDebug()<<QString("DebutCreationLha*%1*%2*").arg(nameofarchive).arg(relativepath)<<endl;
	addFilesToArchive(filestoadd, false, 0,relativepath);
	kdDebug()<<("\nEndCreateLha\n");
}

#include "clha.moc"
