/***************************************************************************
                          crar.cpp  -  description
                             -------------------
    begin                : Sat Dec 2 2000
    copyright            : (C) 2000 by Eric Coquelle
    email                : coquelle@caramail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "crar.h"
#include <kdebug.h>
#include <kmessagebox.h>
#include <qfile.h>
#include <qdir.h>

CRar::CRar(){
  CArchive();

  connect(&processread,SIGNAL(receivedStdout(KProcess*, char*, int)),this,SLOT(haveSdtOut(KProcess*,char*,int)));
  connect(&processread,SIGNAL(processExited (KProcess*)),this,SLOT(endProcess(KProcess*)));
  connect(&processextract,SIGNAL(receivedStdout(KProcess*, char*, int)),this,SLOT(haveSdtOutExtract(KProcess*,char*,int)));
  connect(&processextract,SIGNAL(processExited (KProcess*)),this,SLOT(endProcess(KProcess*)));
  connect(&processextract, SIGNAL(receivedStderr(KProcess *, char *, int)),this, SLOT(haveSdtErrExtract(KProcess*,char*,int)));

  list->setColumnText(4, i18n("Ratio"));
  list->setColumnText(5, i18n("Permissions"));
  passwordrequired=false;
}

CRar::~CRar(){
archivePassword="";
}

/** this method will launch the right compressor
to list the file contents
It will then launch the right method to display
the content in the listview */
void CRar::displayArchiveContent(){
  initializeReadingArchive();

  processread <<"rar";
  processread << "v" << archiveName;

//  m_buffer[0]='\0';
  headerremoved=false;
  finished=false;
  flag=0;
  processread.start(KProcess::NotifyOnExit, KProcess::AllOutput);
}

/** display in a listview the content of the current
rar archive. This method examines the stdout of
unarj to sort useful infos for the listview */
void CRar::displayRarArchiveContent( FILE* flot ){
	CListViewItem* elementListe;
	char tampon[5000];
	char permission[30];
	QString proprietaire;
	char crc[20];
	char taille[30];
	char date[12];
	char heure[7];
	char snom[5000];
	char methode[20];
	QString path;
	QString nom;
	QString message;
	int i;


	do
		fgets( tampon, 5000, flot );
	while( !feof(flot) && (strstr( tampon, "-------------------------------------------------------------------------------" )==NULL));
	fgets( tampon, 5000, flot );
	while( !feof(flot) && (strstr( tampon, "-------------------------------------------------------------------------------" )==NULL))
	{
		sscanf(tampon, " %[a-zA-Z0-9:._-] %[0-9] %[0-9] %[0-9%] %[0-9-] %[0-9:] %[a-zA-Z0-9-] %[a-zA-Z0-9] %[a-zA-Z0-9] %[^\n]",snom, taille, crc, permission, date, heure, crc, crc, crc, methode );

		nom=snom;
		nom=" "+nom;
		i=nom.findRev('/');
		if(i!=-1)
		{
			path=nom.left(i+1);
		 	nom=nom.remove(0,i+1);
		if(nom=="")nom="..";
		}
		else
			path="";
   //Remove the * of the begining of the path (if password protected)
    if(path.startsWith(" *"))
    {
      path=path.remove(1,1);
      passwordrequired=true;
    }
      
		elementListe=new CListViewItem(list,nom,taille,heure,date,proprietaire,permission,path);
		definitIcone(nom, permission, elementListe);
		elementListe->widthChanged();
		fgets( tampon, 5000, flot );
	}
	fclose( flot );
}

/*Overloaded method*/
void CRar::displayRarArchiveContent( const char* line){
	CListViewItem* elementListe;
	QStringList columns;
	QString name, path;
  QStringList date;
  QString fdate;
	int i;
  
  flag++;

  if ( flag== 1)//1st line: name
  {
      m_line1 = line;
      return;
  }
  columns=QStringList::split(' ', line);//2nd line: other informations

  // if we made it here, we have all two lines.
  // Reset the line number.
  flag = 0;

  date=QStringList::split('-', columns[3]);

  name=m_line1;
	name=" "+name.simplifyWhiteSpace();
	i=name.findRev('/');
	if(i!=-1)
	{
		path=name.left(i+1);
	 	name=name.remove(0,i+1);
		if(name=="")name="..";
	}
	else
		path="";
   //Remove the * of the begining of the path (if password protected)
    if(path.startsWith(" *"))
    {
      path=path.remove(1,1);
      passwordrequired=true;
    }
      
	/*year has only two digits !
  if(kindofdate==STANDARD_DATE)
		fdate=columns[3];
	else if(kindofdate==LOCALISED_DATE)
		fdate=KGlobal::locale()->formatDate(QDate(date[2].toInt(),date[1].toInt(),date[0].toInt()), true);
	else if(kindofdate==LOCALISED_FULL_DATE)
	  fdate=KGlobal::locale()->formatDate(QDate(date[2].toInt(),date[1].toInt(),date[0].toInt()), false);*/

  elementListe=new CListViewItem(list,name,columns[0],columns[4],columns[3],columns[2],columns[5],path);
  if(QString(columns[5]).contains("D",false))
	  definitIcone( ".", columns[5], elementListe);
  else
	  definitIcone( name, columns[5], elementListe);
  
	elementListe->widthChanged();
}

/** we recive some informations through the standard
output of the process */
void CRar::haveSdtOut(KProcess *, char *buffer, int length){
	//Has user canceled current action ?
	if(stopreadprocess)
		return;

	// This section has been taken from ark:
	//1997-1999: Rob Palmbos palm9744@kettering.edu
	//2000: Corel Corporation (author: Emily Ezust, emilye@corel.com)
	//and adapted to karchiver
  displayMessage(i18n("Running compressor..."));


  char c = buffer[length];
  buffer[length] = '\0';

  int lfChar, startChar = 0;

  while(!finished)
  {
  	for(lfChar = startChar; buffer[lfChar] != '\n' && lfChar < length;
	    lfChar++);

	if(buffer[lfChar] != '\n') break;	// We are done all the complete lines

	buffer[lfChar] = '\0';
	m_buffer.append(buffer + startChar);
	buffer[lfChar] = '\n';
	startChar = lfChar + 1;

  if( m_buffer.find("--------") == -1 )
	{
		if( headerremoved && !finished)
		{
			displayRarArchiveContent(m_buffer);
		}
	}
	else if(!headerremoved)
		headerremoved = true;
	else
		finished = true;

	m_buffer = "";
  }
  if(!finished)
	m_buffer.append(buffer + startChar);	// Append what's left of the buffer

  buffer[length] = c;
}

/** we recive some informations through the standard
	* output of the process */
void CRar::haveSdtOutExtract(KProcess *, char *buffer, int length){
	QString inter;
	int i=0;

	inter=buffer;
	inter=inter.left(length);

	while((i=inter.find('\n',i+1))!=-1){
		progressbar->setProgress(progressbar->progress()+1);
	}
}

/** we recive some informations through the error
	* output of the process */
void CRar::haveSdtErrExtract(KProcess *, char *buffer, int length){
  buffer[length]=0;

  kdDebug()<<("Error during extraction: ")<<(buffer)<<("\n");

  if (strstr(buffer,"incorrect password")) {
    KMessageBox::error(NULL, i18n("An error occured during extraction: \n The archive is password protected and the given password is wrong.\nPlease, choose 'Archive->Set Password', change the password and try it again."));
    return;
  }
    KMessageBox::error(NULL, i18n("An unkown error occured during extraction:\n") +QString(buffer));
}

/** The current process ended */
void CRar::endProcess(KProcess*){
  kdDebug()<<("Process ENDED\n");
	led->setColor(QColor("green"));
	displayMessageArchiveSize();
	progressbar->reset();

	emit(archiveReadEnded());
}

/** Upon the kind of archive, choose the right
	*uncompressor and extract all or some files
	*@extractall = 9: extract to karchiveur's temp directory (for viewing)
	*@extractall = 1: extract all selected files
	*/
void CRar::extractArchive(QString & extractpath, int extractall, QString &filetoextract){
 	QString directoryOption;
 	QString nomextrait;
 	QString fichiersaextraire;

	directoryOption="";
	fichiersaextraire="";
	counter=0;
	progressbar->reset();
	progressbar->setTotalSteps(list->childCount());

 	processextract.clearArguments();
 	processextract << "unrar";
	processextract << "x";
	processextract << "-y";
  if(!archivePassword.isEmpty())
    processextract << "-p"+archivePassword;
  else if(passwordrequired)
  {
    KMessageBox::error(NULL, i18n("An error occured during extraction: \n The archive is password protected and the given password is wrong.\nPlease, choose 'Archive->Set Password', change the password and try it again."));
    return;
  }
  else
    processextract << "-p-";  

  //Always overwrite as we made checkFiles
  //if(!overwrite)
  processextract << "-o+";

  processextract << archiveName;

  //We will extract all selected files
  if((extractall!=EXTRACTANDOVERWRITE)&&(extractall!=EXTRACTONE_ANDBLOCK)&&(!checkFiles(extractpath, extractall)))
  {
    endProcess(NULL);
    return;
  }
    
 	//We want to view (and so extract) only one file. So we just add this file to the tar or unzip
 	//command. For gzip and bzip2 files, in any case, we extract one and only one file, so I put
 	//it apart
 	else if(extractall==EXTRACTONE_ANDBLOCK)
 	{
    kdDebug()<<QString("Viewing %1 with pass %2").arg(filetoextract).arg(archivePassword);
 		processextract << filetoextract;
	 	processextract << extractpath;
 		if(processextract.start(KProcess::Block)==FALSE)
		  kdDebug()<<("\n*PB PROCESS*\n");
 	}

 	//We extract through the Stdout to have a progress indicator
 	if(extractall!=EXTRACTONE_ANDBLOCK)
 	{
	 	processextract << extractpath;
 		if(processextract.start(KProcess::NotifyOnExit,KProcess::Stdout)==FALSE)
		  kdDebug()<<("\n*PB PROCESS*\n");
 	}
 	counter=0;
}

/** delete @param filestodelete from current archive */
void CRar::removeFilesFromArchive (QStrList filestodelete){
  kdDebug()<<("In:removeFilesFromArchive_RAR\n");
 	processread.clearArguments();
 	processread << "rar" << "d";
 	processread << archiveName;
  for (QString f = filestodelete.first(); f; f = filestodelete.next())
  {
    kdDebug()<<QString("Will remove:%1*").arg(f)<<endl;
    processread << f;
  }
  processread.start(KProcess::Block);
  kdDebug()<<("Ok:removeFilesFromArchive_RAR\n");
}

/** Add some files to the archive
@param filestoadd : list of files to add
@param removeoriginalfiles : remove or not those files from disk
@param action : 0=mode append and replace files, 1=mode update files
@param relativepath : if !NULL, include only filenames, without their base path */
void CRar::addFilesToArchive( QStrList filestoadd, bool removeoriginalfiles, int action, const char* relativepath){
	QString s;

	if(relativepath!=NULL)
		QDir::setCurrent(relativepath);

	processread.clearArguments();
	processread << "rar";
	processread << "a";
	
	switch(action)
	{
		case 1:
			//Mode update
			processread << "-u";
			break;
	}
	
	if(removeoriginalfiles)
		processread << "-df";
	
	if(recursivemode)
		processread << "-r";

	processread << archiveName;
	for (QString f = filestoadd.first(); f; f = filestoadd.next())
	{
	  s=f;
	  if(s.right(1)=="/")
	    s.truncate(s.length()-1);
	  if(s.find("file:")==0)
	    s.remove(0,5);
	  kdDebug()<<QString("AjArchRar:%1*in:%2*").arg(s).arg(archiveName)<<endl;
  	processread << s;
	}
	processread.start(KProcess::Block);
}

/** Create a rar archive
@param  nameofarchive: the name of the zip archive
@param param: list of files to add
@param relativepath: include only filenames, without their path */
void CRar::createArchive(QString nameofarchive, QStrList filestoadd, const char* relativepath) {
	QString str;

	archiveName=nameofarchive;
	kdDebug()<<QString("DebutCreationRar*%1*%2*").arg(nameofarchive).arg(relativepath)<<endl;
	addFilesToArchive(filestoadd, false, 0,relativepath);
	kdDebug()<<("\nEndCreateRar\n");
}

/** Returns true if archive type supports passwords */
bool CRar::supportPassword(){
 return true;
}

#include "crar.moc"
