/***************************************************************************
                          ctar.cpp  -  description
                             -------------------
    begin                : Tue Dec 19 2000
    copyright            : (C) 2000 by Eric Coquelle
    email                : coquelle@caramail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "ctar.h"
#include <kdebug.h>

CTar::CTar(){
	CArchive();

  connect(&processread,SIGNAL(receivedStdout(KProcess*, char*, int)),this,SLOT(haveSdtOut(KProcess*,char*,int)));
	connect(&processread,SIGNAL(processExited (KProcess*)),this,SLOT(endProcess(KProcess*)));
	connect(&processextract,SIGNAL(receivedStdout(KProcess*, char*, int)),this,SLOT(haveSdtOutExtract(KProcess*,char*,int)));
	connect(&processextract,SIGNAL(processExited (KProcess*)),this,SLOT(endProcess(KProcess*)));
  connect(&processread,SIGNAL(receivedStderr(KProcess*, char*, int)),this,SLOT(haveStdErr(KProcess*,char*,int)));

  list->setColumnText(4, i18n("Owner"));
	list->setColumnText(5, i18n("Permissions"));
}

CTar::~CTar(){
}

/** this method will launch the right compressor
to list the file contents
It will then launch the right method to display
the content in the listview */
void CTar::displayArchiveContent(){
/*KIO_KARCHIVE*/
  if(viewbydirectories)
  {
    tarfile=new KTar(archiveName);
    tarfile->open(IO_ReadOnly);
    CArchive::displayArchiveContent(tarfile->directory(),QString::null);
    endProcess(NULL);
  }
  else
  {
  	FILE *flot;

  	initializeReadingArchive();

  	processread << "tar";
  	processread << "-vtf" << archiveName;

  	if(readArchiveWithStream)
  	{
  			processread.demarrer(&flot,KProcess::AllOutput);
  			displayTarArchiveContent(flot);
  			displayMessageArchiveSize();
  			led->setColor(KLed::green);
  	}
  	else
  	{
  		m_buffer[0]='\0';
  		processread.start(KProcess::NotifyOnExit, KProcess::AllOutput);
  	}
  }
}

/* This method display, using some (fine ?) icons
the content of the current archive */
void CTar::displayTarArchiveContent(FILE* flot){
	CListViewItem* elementListe=NULL;
	char tampon[5000];
	char permission[30];
	char proprietaire[256];
	char taille[30];
	QString date;
	char heure[9];
	char snom[5000];
	char year[5];
	char month[2];
	char day[2];
	QString y, m, d;
	QString chemin;
	QString nom;
	QString message;
	int i;

	fgets( tampon, 5000, flot );
	while( !feof(flot) )
	{
		sscanf(tampon, " %[-drwxstl] %[0-9a-zA-Z./_] %[0-9] %[0-9]-%[0-9]-%[0-9] %[0-9:-] %[^\n]",permission, proprietaire, taille, year, month, day, heure, snom );

		nom=snom;
		i=nom.findRev('/');
		if(i!=-1)
		{
			chemin=" "+nom.left(i+1);
		 	nom=nom.remove(0,i+1);
		if(nom=="")nom="..";
		}
		else
			chemin=" ";

		y=year;
		m=month;
		m.truncate(2);
		d=day;
		date=y+"-"+m+"-"+d;

		if(kindofdate==STANDARD_DATE)
		  elementListe=new CListViewItem(list,nom,taille,heure,date, proprietaire,permission,chemin);
		else if(kindofdate==LOCALISED_DATE)
			elementListe=new CListViewItem(list,nom,taille,heure,KGlobal::locale()->formatDate(QDate(y.toInt(),m.toInt(),d.toInt()), true),proprietaire,permission,chemin);
		else if(kindofdate==LOCALISED_FULL_DATE)
			elementListe=new CListViewItem(list,nom,taille,heure,KGlobal::locale()->formatDate(QDate(y.toInt(),m.toInt(),d.toInt()), false),proprietaire,permission,chemin);
		definitIcone(nom, permission, elementListe);
		elementListe->widthChanged();
		fgets( tampon, 5000, flot );
	}
	fclose( flot );
}

/*Overloaded method*/
void CTar::displayTarArchiveContent(const QString & ligne){
	CListViewItem* elementListe=NULL;
	char permission[30];
	char proprietaire[256];
	char taille[30];
	QString date;
	char year[5];
	char month[2];
	char day[2];
	char heure[9];
	char snom[5000];
	QString chemin;
	QString nom;
	QString message;
	QString y, m, d;
	int i;

	sscanf(ligne.latin1(), " %[-drwxstl] %[0-9a-zA-Z./_] %[0-9] %[0-9]-%[0-9]-%[0-9] %[0-9:-] %[^\n]",permission, proprietaire, taille, year, month, day, heure, snom );

		nom=snom;
		i=nom.findRev('/');
		if(i!=-1)
		{
		  chemin=" "+nom.left(i+1);
		  nom=nom.remove(0,i+1);
		  if(nom.isEmpty())
		    nom="..";
		}
		else
		  chemin=" ";

		y=year;
		m=month;
		m.truncate(2);
		d=day;
		date=y+"-"+m+"-"+d;

    if(kindofdate==LOCALISED_DATE)
			date=KGlobal::locale()->formatDate(QDate(y.toInt(),m.toInt(),d.toInt()), true);
		else if(kindofdate==LOCALISED_FULL_DATE)
		  date=KGlobal::locale()->formatDate(QDate(y.toInt(),m.toInt(),d.toInt()), false);
      
    elementListe=new CListViewItem(list,nom,taille,heure,date,proprietaire,permission,chemin);
		if(displayicons)
			definitIcone(nom, permission, elementListe);
		elementListe->widthChanged();
}

/** we recive some informations through the standard
output of the process */
void CTar::haveSdtOut(KProcess *, char *buffer, int length){
	//Has user canceled current action ?
	if(stopreadprocess)
		return;

	// This section is here only for testing. It has been taken from ark:
	//1997-1999: Rob Palmbos palm9744@kettering.edu
	//2000: Corel Corporation (author: Emily Ezust, emilye@corel.com)
	//and adapted to karchiveur
  char c = buffer[length];
  buffer[length] = '\0';

//  m_settings->appendShellOutputData( buffer );

  char line[1024] = "";
  char *tmpl = line;
  char *tmpb;

  displayMessage(i18n("Running compressor..."));


  //We copy m_buffer to tmpl
  for( tmpb = m_buffer; *tmpb != '\0'; tmpl++, tmpb++ )
    *tmpl = *tmpb;

  //We copy the fisrt string of buffer (till \n) to tmpl
  for( tmpb = buffer; *tmpb != '\n'; tmpl++, tmpb++ )
    *tmpl = *tmpb;

  tmpb++;
  *tmpl = '\0';

  if( *tmpb == '\0' )
    m_buffer[0]='\0';

	displayTarArchiveContent( line );
  bool stop = (*tmpb == '\0');

  while( !stop)
  {
      tmpl = line; *tmpl = '\0';

      for(; (*tmpb!='\n') && (*tmpb!='\0'); tmpl++, tmpb++)
				*tmpl = *tmpb;

      if( *tmpb == '\n' )
			{
			  *tmpl = '\n';
			  tmpl++;
			  *tmpl = '\0';
			  tmpb++;
	  		displayTarArchiveContent( line );
			}
      else if (*tmpb == '\0' )
			{
	  		*tmpl = '\0';
			  strcpy( m_buffer, line );
	  		stop = true;
			}
    }
  buffer[length] = c;
}

/** we recive some informations through the standard
output of the process */
void CTar::haveSdtOutExtract(KProcess *, char *buffer, int length){
	QString inter;
	int i=0;

	inter=buffer;
	inter=inter.left(length);

	while((i=inter.find('\n',i+1))!=-1){
		progressbar->setProgress(progressbar->progress()+1);
	}
}

/** The current process ended */
void CTar::endProcess(KProcess*){
  kdDebug()<<("CTar Process ENDED\n");

	led->setColor(QColor("green"));
	displayMessageArchiveSize();
	progressbar->reset();

	emit(archiveReadEnded());
}

/** Upon the kind of archive, choose the right
	*uncompressor and extract all or some files
	*@toutextraire = 9: extract to karchiveur's temp directory (for viewing)
	*@toutextraire = 1: extract all selected files
	*/
void CTar::extractArchive(QString & extractpath, int extractall, QString & filetoextract){
 	QString optionRepertoire;
 	QString nomextrait;
 	QString fichiersaextraire;
  QStringList listsubdir;

	optionRepertoire="";
	fichiersaextraire="";
	counter=0;
	progressbar->reset();
	progressbar->setTotalSteps(list->childCount());

	processextract.clearArguments();
	processextract << "tar";

	optionRepertoire="-C";
	optionRepertoire+=extractpath;
	processextract << "-vxf";
	if(!overwrite)
		processextract << "-k";

 	processextract << archiveName;
  processextract << optionRepertoire;

	//We will extract all selected files
  if((extractall!=EXTRACTANDOVERWRITE)&&(extractall!=EXTRACTONE_ANDBLOCK)&&(!checkFiles(extractpath, extractall)))
  {
    endProcess(NULL);
    return;
  }

  //We want to view (and so extract) only one file. So we just add this file to the tar or unzip
	//command. For gzip and bzip2 files, in any case, we extract one and only one file, so I put
	//it apart
	else if(extractall==EXTRACTONE_ANDBLOCK)
	{
		processextract << filetoextract;
		if ( processextract.start(KProcess::Block) == FALSE )
			kdDebug()<<("\n*PB PROCESS*\n");
	}

	//We extract through the Stdout to have a progress indicator
	if(extractall!=EXTRACTONE_ANDBLOCK)
	{
		if(processextract.start(KProcess::NotifyOnExit,KProcess::Stdout)==FALSE)
		  kdDebug()<<("\n*PB PROCESS*\n");
	}
	counter=0;
}

/** delete @param filestodelete from current archive */
void CTar::removeFilesFromArchive (QStrList filestodelete){
 	processread.clearArguments();
 	processread << "tar" << "--delete" << "-f";
 	processread << archiveName;
  for (QString f = filestodelete.first(); f; f = filestodelete.next())
  {
    kdDebug()<<QString("Will remove:%1*").arg(f)<<endl;
    processread << f;
  }
 	processread.start(KProcess::Block);
	kdDebug()<<("Ok:removeFichiersArchiveTar\n");
}

/** Add some files to the archive
@param filestoadd : list of files to add
@param removeoriginalfiles : remove or not those files from disk
@param action : 0=mode append and replace files, 1=mode update files
@param relativepath : if !NULL, include only filenames, without their base path */
void CTar::addFilesToArchive( QStrList filestoadd, bool removeoriginalfiles, int action, const char* relativepath){
  kdDebug()<<QString("IN:CTar::addFilesToArchive - relpath=%1*").arg(relativepath)<<endl;
 	processread.clearArguments();
 	processread << "tar";

 	if(removeoriginalfiles)
 		processread << "--remove-files";
 	if(!recursivemode)
 		processread << "--no-recursion";
 	if(relativepath!=NULL)
 		processread << "-C" << relativepath;

 	switch(action)
 	{
 		case 1:
 			//Mode update
 			processread << "-uf";
 			break;
 		default:
 		case 0:
 			//Mode append
 			processread << "-rf";
 			break;
 	}
  processread << archiveName;
  for (QString f = filestoadd.first(); f; f = filestoadd.next())
 	{
	  kdDebug()<<QString("\nAjArchTar:%1*").arg(f)<<endl;
   	processread << f;
  }
 	processread.start(KProcess::Block);
}

/** Create a tar archive
@param  nameofarchive: the name of the pure .tar archive
@param param: list of files to add
@param relativepath: include only filenames, without their path */
void CTar::createArchive(QString nameofarchive, QStrList filestoadd, const char* relativepath){
//	QString str;
  kdDebug()<<QString("BeginCreatingTar*%1*%2*").arg(nameofarchive).arg(relativepath)<<endl;
  archiveName=nameofarchive;
  addFilesToArchive(filestoadd, false, 0,relativepath);
  /*processread.clearArguments();
    processread << "tar" << "-c";
    if(relativepath!=NULL)
    process << "-C" << relativepath;
    for (QString f = strliste.first(); f; f = strliste.next())
    {
    str=f;
    str=str.right(str.length()-str.find(":")-1);
    *process << str;
    }
    *process << "-f" << nomArchive;
    process->start(KProcess::Block);*/
}

#include "ctar.moc"
