/***************************************************************************
                          ctargz.cpp  -  description
                             -------------------
    begin                : Sat Dec 2 2000
    copyright            : (C) 2000 by Eric Coquelle
    email                : coquelle@caramail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "ctargz.h"
#include <kdebug.h>


CTarGz::CTarGz()
{
	CTar();
}

CTarGz::~CTarGz(){
}

/** this method will launch the right compressor
to list the file contents
It will then launch the right method to display
the content in the listview */
void CTarGz::displayArchiveContent(){
//KIO_KARCHIVE
  if(viewbydirectories)
    CTar::displayArchiveContent();
  else
  {
    FILE *flot;

    initializeReadingArchive();

    processread << "tar";
    processread << "-zvtf" << archiveName;

    if(readArchiveWithStream)
    {
        processread.demarrer(&flot,KProcess::AllOutput);
        displayTarArchiveContent(flot);
        displayMessageArchiveSize();
        led->setColor(KLed::green);
    }
    else
    {
        m_buffer[0]='\0';
        processread.start(KProcess::NotifyOnExit, KProcess::AllOutput);
    }
  }
}
  
/** Upon the kind of archive, choose the right
	*uncompressor and extract all or some files
	*@extractall = 9: extract to karchiveur's temp directory (for viewing)
	*@extractall = 1: extract all selected files
	*/
void CTarGz::extractArchive(QString & extractpath, int extractall, QString & filetoextract){
 	QString optionRepertoire;
 	QString nomextrait;
 	QString fichiersaextraire;
  QStringList listsubdir;

 	optionRepertoire="";
 	fichiersaextraire="";
 	counter=0;
 	progressbar->reset();
	progressbar->setTotalSteps(list->childCount());

 	processextract.clearArguments();
 	processextract << "tar";

	optionRepertoire="-C";
	optionRepertoire+=extractpath;
	processextract << "-zvxf";
	if(!overwrite)
		processextract << "-k";

 	processextract << archiveName;
  processextract << optionRepertoire;
kdDebug()<<QString("CTarGz::extractArchive name:%1 path:%2 extractall:%4 file:%3\n").arg(archiveName).arg(optionRepertoire).arg(filetoextract).arg(extractall);
 	//We will extract all selected files
  if((extractall!=EXTRACTANDOVERWRITE)&&(extractall!=EXTRACTONE_ANDBLOCK)&&(!checkFiles(extractpath, extractall)))
  {
    endProcess(NULL);
    kdDebug()<<QString("Pb with checkFiles, ending process")<<endl;
    return;
  }

  //We want to view (and so extract) only one file. So we just add this file to the tar or unzip
 	//command. For gzip and bzip2 files, in any case, we extract one and only one file, so I put
 	//it apart
 	else if(extractall==EXTRACTONE_ANDBLOCK)
 	{
 		processextract << filetoextract;
 		if(processextract.start(KProcess::Block)==FALSE)
		  kdDebug()<<("\n*PB PROCESS*\n");
 	}

 	//We extract through the Stdout to have a progress indicator
 	if(extractall!=EXTRACTONE_ANDBLOCK)
 	{
 		if(processextract.start(KProcess::NotifyOnExit,KProcess::Stdout)==FALSE)
		  kdDebug()<<("\n*PB PROCESS*\n");
 	}
 	counter=0;
}

/** delete @param filestodelete from current archive */
void CTarGz::removeFilesFromArchive( QStrList filestodelete ){
	QString comprrate;

	comprrate.sprintf("-%i",compressrate);

	processextract.clearArguments();
	processextract << "gzip" << "-df" << archiveName;
	processextract.start(KProcess::Block);

	//The name of archive arch.tar.gz is now arch.tar
	if(archiveName.right(4)==".tgz")
	{
		//it can be called arch.tgz
		archiveName=archiveName.left(archiveName.length()-3);
		archiveName+="tar";
	}
	else
		archiveName=archiveName.left(archiveName.length()-3);

	CTar::removeFilesFromArchive(filestodelete);

	processread.clearArguments();
	processread << "gzip" << comprrate << archiveName;
	processread.start(KProcess::Block);
	archiveName+=".gz";
}

/** Add some files to the archive
@param filestoadd : list of files to add
@param removeoriginalfiles : remove or not those files from disk
@param action : 0=mode append and replace files, 1=mode update files
@param relativepath : if !NULL, include only filenames, without their base path */
void CTarGz::addFilesToArchive( QStrList filestoadd, bool removeoriginalfiles, int action, const char* relativepath){
  kdDebug()<<("\nDecompression GZIP\n");
	QString comprrate;

	comprrate.sprintf("-%i",compressrate);

 	processread.clearArguments();
 	processread << "gzip" << "-df" << archiveName;
 	processread.start(KProcess::Block);

	//The name of archive arch.tar.gz is now arch.tar
	if(archiveName.right(4)==".tgz")
	{
		//it can be called arch.tgz
		archiveName=archiveName.left(archiveName.length()-3);
		archiveName+="tar";
	}
	else
		archiveName=archiveName.left(archiveName.length()-3);

	kdDebug()<<("\nDecompression GZIP OK\n");
 	//We add files to the pure tar archive
 	CTar::addFilesToArchive(filestoadd, removeoriginalfiles, action, relativepath);
	kdDebug()<<("\nADD TAR OK\n");
 	//Then we compress with gzip
 	processread.clearArguments();
 	processread << "gzip" << comprrate << archiveName;
 	processread.start(KProcess::Block);

	archiveName+=".gz";
	kdDebug()<<("\nCompression GZIP OK\n");
}

void CTarGz::createArchive(QString nameofarchive, QStrList filestoadd, const char* relativepath) {
	QString comprrate;

	comprrate.sprintf("-%i",compressrate);
	archiveName=nameofarchive;

	//The name of archive arch.tar.gz is now arch.tar
	if(archiveName.right(4)==".tgz")
	{
		//it can be called arch.tgz
		archiveName=archiveName.left(archiveName.length()-3);
		archiveName+="tar";
	}
	else
		archiveName=archiveName.left(archiveName.length()-3);

	kdDebug()<<("\nDecompression GZIP OK\n");
 	//We add files to the pure tar archive
 	CTar::addFilesToArchive(filestoadd, false, 0, relativepath);
	kdDebug()<<("\nADD TAR OK\n");
 	//Then we compress with gzip
 	processread.clearArguments();
 	processread << "gzip" << comprrate << archiveName;
 	processread.start(KProcess::Block);

	archiveName+=".gz";
	kdDebug()<<("\nCompression GZIP OK\n");
}
#include "ctargz.moc"
