/***************************************************************************
                          czip.cpp  -  description
                             -------------------
    begin                : Sat Dec 2 2000
    copyright            : (C) 2000 by Eric Coquelle
    email                : coquelle@caramail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "czip.h"
#include <kdebug.h>
#include <kmessagebox.h> 
#include <qdir.h>

CZip::CZip(){
	CArchive();

	connect(&processread,SIGNAL(receivedStdout(KProcess*, char*, int)),this,SLOT(haveSdtOut(KProcess*,char*,int)));
	connect(&processread,SIGNAL(processExited (KProcess*)),this,SLOT(endProcess(KProcess*)));
	connect(&processextract,SIGNAL(receivedStdout(KProcess*, char*, int)),this,SLOT(haveSdtOutExtract(KProcess*,char*,int)));
	connect(&processextract,SIGNAL(processExited (KProcess*)),this,SLOT(endProcess(KProcess*)));
  connect(&processextract, SIGNAL(receivedStderr(KProcess *, char *, int)),this, SLOT(haveSdtErrExtract(KProcess*,char*,int)));

	list->setColumnText(4, i18n("Packed"));
	list->setColumnText(5, i18n("Ratio"));
}

CZip::~CZip(){
archivePassword="";
}

/** this method will launch the right compressor
	to list the file contents
	It will then launch the right method to display
	the content in the listview */
void CZip::displayArchiveContent(){
/*KIO_KARCHIVE*/
  if(viewbydirectories)
  {
    zipfile=new KZip(archiveName);
    zipfile->open(IO_ReadOnly);
    CArchive::displayArchiveContent(zipfile->directory(),QString::null);
    endProcess(NULL);
  }
  else
  {
  	FILE *flot;

  	initializeReadingArchive();

    processread << "unzip";
  	processread << "-lv" << archiveName;

  	if(readArchiveWithStream)
  	{
  		processread.demarrer(&flot,KProcess::AllOutput);
  		displayZipArchiveContent(flot);
  		displayMessageArchiveSize();
  		led->setColor(KLed::green);
  	}
  	else
  	{
  		m_buffer[0]='\0';
  		headerremoved=false;
  		finished=false;
  		processread.start(KProcess::NotifyOnExit, KProcess::AllOutput);
  	}
  }
}
/** display in a listview the content of the current
zip archive. This method examines the stdout of
unarj to sort useful infos for the listview */
void CZip::displayZipArchiveContent( FILE *flot ){
	CListViewItem* elementListe=NULL;
	char tampon[5000];
	char permission[30];
	char proprietaire[256];
	char crc[20];
	char taille[30];
	QString date;
	QString y, m, d;
	char year[5];
	char month[2];
	char day[2];
	char heure[7];
	char snom[5000];
	char methode[20];
	QString chemin;
	QString nom;
	QString message;
	int i;

	do
		fgets( tampon, 5000, flot );
	while( !feof(flot) && (strstr( tampon, "----" )==NULL));
	fgets( tampon, 5000, flot );
	while( !feof(flot) && (strstr( tampon, "----" )==NULL))
	{
		sscanf(tampon, "  %[0-9]  %[a-zA-Z:]   %[0-9]  %[0-9%]  %[0-9]-%[0-9]-%[0-9]  %[0-9:]  %[a-zA-Z0-9]   %[^\n]",taille, methode, proprietaire, permission, year, month, day, heure, crc, snom );

		nom=snom;
		nom=" "+nom;
		i=nom.findRev('/');
		if(i!=-1)
		{
			chemin=nom.left(i+1);
		 	nom=nom.remove(0,i+1);
		if(nom=="")nom="..";
		}
		else
			chemin="";

		y=year;
		m=month;
		m.truncate(2);
		d=day;
		date=y+"-"+m+"-"+d;

		if(kindofdate==STANDARD_DATE)
			elementListe=new CListViewItem(list,nom,taille,heure,date, proprietaire,permission,chemin);
		else if(kindofdate==LOCALISED_DATE)
			elementListe=new CListViewItem(list,nom,taille,heure,KGlobal::locale()->formatDate(QDate(y.toInt(),m.toInt(),d.toInt()), true),proprietaire,permission,chemin);
		else if(kindofdate==LOCALISED_FULL_DATE)
			elementListe=new CListViewItem(list,nom,taille,heure,KGlobal::locale()->formatDate(QDate(y.toInt(),m.toInt(),d.toInt()), false),proprietaire,permission,chemin);

//		elementListe=new QListViewItem(liste,(const char*)nom,taille,heure,date,proprietaire,permission,(const char*)chemin);
		definitIcone(nom, permission, elementListe);
		elementListe->widthChanged();
		fgets( tampon, 5000, flot );
	}
	fclose( flot );
}

/*Overloaded method*/
void CZip::displayZipArchiveContent( const char* ligne){
	CListViewItem* elementListe=NULL;
	char permission[30];
	char proprietaire[256];
	char crc[20];
	char taille[30];
	QString date;
	QString y, m, d;
	char year[5];
	char month[2];
	char day[2];
	char heure[7];
	char snom[5000];
	char methode[20];
	QString chemin;
	QString nom;
	QString message;
	int i;

		sscanf(ligne, "  %[0-9]  %[a-zA-Z:]   %[0-9]  %[0-9%]  %[0-9]-%[0-9]-%[0-9]  %[0-9:]  %[a-zA-Z0-9]   %[^\n]",taille, methode, proprietaire, permission, year, month, day, heure, crc, snom );

		nom=snom;
		nom=" "+nom;
		i=nom.findRev('/');
		if(i!=-1)
		{
			chemin=nom.left(i+1);
		 	nom=nom.remove(0,i+1);
		if(nom=="")nom="..";
		}
		else
			chemin="";

		y=year;
		m=month;
		m.truncate(2);
		d=day;
		date=y+"-"+m+"-"+d;

		if(kindofdate==STANDARD_DATE)
		  elementListe=new CListViewItem(list,nom,taille,heure,date, proprietaire,permission,chemin);
		else if(kindofdate==LOCALISED_DATE)
			elementListe=new CListViewItem(list,nom,taille,heure,KGlobal::locale()->formatDate(QDate(y.toInt(),m.toInt(),d.toInt()), true),proprietaire,permission,chemin);
		else if(kindofdate==LOCALISED_FULL_DATE)
		  elementListe=new CListViewItem(list,nom,taille,heure,KGlobal::locale()->formatDate(QDate(y.toInt(),m.toInt(),d.toInt()), false),proprietaire,permission,chemin);

//		elementListe=new QListViewItem(liste,(const char*)nom,taille,heure,date,proprietaire,permission,(const char*)chemin);
		definitIcone(nom, permission, elementListe);
		elementListe->widthChanged();
}

/** we recive some informations through the standard
output of the process */
void CZip::haveSdtOut(KProcess *, char *buffer, int length){
	//Has user canceled current action ?
	if(stopreadprocess)
		return;

	// This section is here only for testing. It has been taken from ark:
	//1997-1999: Rob Palmbos palm9744@kettering.edu
	//2000: Corel Corporation (author: Emily Ezust, emilye@corel.com)
	//and adapted to karchiveur
//	int passage;
  char c = buffer[length];
  buffer[length] = '\0';

//  m_settings->appendShellOutputData( buffer );

  char line[1024] = "";
  char *tmpl = line;
  char *tmpb;

  displayMessage(i18n("Running compressor..."));


  //We copy m_buffer to tmpl
  for( tmpb = m_buffer; *tmpb != '\0'; tmpl++, tmpb++ )
    *tmpl = *tmpb;

  //We copy the fisrt string of buffer (till \n) to tmpl
  for( tmpb = buffer; *tmpb != '\n'; tmpl++, tmpb++ )
    *tmpl = *tmpb;

  tmpb++;
  *tmpl = '\0';

  if( *tmpb == '\0' )
    m_buffer[0]='\0';

  if( !strstr( line, "----" ) )
	{
  	if( headerremoved && !finished )
  	{
//	if((strncmp(line,"Archive: ",9)!=0)&&(strncmp(line," Length   Method",16)!=0))
			displayZipArchiveContent( line );
		}
	}
  else if(!headerremoved)
    headerremoved = true;
  else
    finished = true;

  bool stop = (*tmpb == '\0');
//  passage=0;

  while( !stop && !finished)
  {
      tmpl = line; *tmpl = '\0';

      for(; (*tmpb!='\n') && (*tmpb!='\0'); tmpl++, tmpb++)
				*tmpl = *tmpb;

      if( *tmpb == '\n' )
			{
			  *tmpl = '\n';
			  tmpl++;
			  *tmpl = '\0';
			  tmpb++;

      if( !strstr( line, "----" ) )
    	{
      	if( headerremoved && !finished )
      	{
    //	if((strncmp(line,"Archive: ",9)!=0)&&(strncmp(line," Length   Method",16)!=0))
    			displayZipArchiveContent( line );
    		}
    	}
      else if(!headerremoved)
        headerremoved = true;
      else
        finished = true;
/*	  	if((passage<1)&&(strncmp(line,"--------",8)!=0)&&(strncmp(line," Length   Method",16)!=0))
  			displayZipArchiveContent( line );
  		else
  			passage++;*/
			}
      else if (*tmpb == '\0' )
			{
	  		*tmpl = '\0';
			  strcpy( m_buffer, line );
	  		stop = true;
			}
    }
  buffer[length] = c;
}

/** we recive some informations through the error
	* output of the process */
void CZip::haveSdtErrExtract(KProcess *, char *buffer, int length){
  buffer[length]=0;

  kdDebug()<<("Error during extraction: ")<<(buffer)<<("\n");
     
  if (strstr(buffer,"incorrect password")) {
    KMessageBox::error(NULL, i18n("An error occured during extraction: \n The archive is password protected and the given password is wrong.\nPlease, choose 'Archive->Set Password', change the password and try it again."));
    return;
  }
    KMessageBox::error(NULL, i18n("An unkown error occured during extraction:\n") +QString(buffer));
}


/** we recive some informations through the standard
	* output of the process */
void CZip::haveSdtOutExtract(KProcess *, char *, int ){
	counter++;
	if(counter%2==0)
		progressbar->setProgress(progressbar->progress()+ 1 );

}

/** The current process ended */
void CZip::endProcess(KProcess*){
  kdDebug()<<("Process ENDED\n");
	led->setColor(QColor("green"));
	displayMessageArchiveSize();
	progressbar->reset();

	emit(archiveReadEnded());
}

/** Upon the kind of archive, choose the right
	*uncompressor and extract all or some files
	*@toutextraire = 9: extract to karchiveur's temp directory (for viewing)
	*@toutextraire = 1: extract all selected files
	*/
void CZip::extractArchive(QString & extractpath, int extractall, QString &filetoextract){
 	QString optionRepertoire;
 	QString nomextrait;
 	QString fichiersaextraire;
  QStringList listsubdir;

 	optionRepertoire="";
 	fichiersaextraire="";
 	counter=0;
 	progressbar->reset();
  progressbar->setTotalSteps(list->childCount());

 	processextract.clearArguments();
 	processextract << "unzip";

	optionRepertoire="-d";
	optionRepertoire+=extractpath;

  processextract << "-P";
  if(archivePassword.isEmpty()) 
    processextract << "''";
  else 
    processextract << archivePassword; 

  //unused as we make a check
  //if(overwrite)
  processextract << "-o";
  //else
    //processextract << "-n";

 	processextract << archiveName;
  processextract << optionRepertoire;

 	//We will extract all selected files
  if((extractall!=EXTRACTANDOVERWRITE)&&(extractall!=EXTRACTONE_ANDBLOCK)&&(!checkFiles(extractpath, extractall)))
  {
    endProcess(NULL);
    return;
  }

  //We want to view (and so extract) only one file. So we just add this file to the tar or unzip
 	//command. For gzip and bzip2 files, in any case, we extract one and only one file, so I put
 	//it apart
 	else if(extractall==EXTRACTONE_ANDBLOCK)
 	{
 		processextract << filetoextract;
  if(processextract.start(KProcess::Block,KProcess::AllOutput)==FALSE)
		  kdDebug()<<("\n*PB PROCESS*\n");
 	}

 	//We extract through the Stdout to have a progress indicator
 	if(extractall!=EXTRACTONE_ANDBLOCK)
 	{
 		if(processextract.start(KProcess::NotifyOnExit,KProcess::AllOutput)==FALSE)
		  kdDebug()<<("\n*PB PROCESS*\n");
 	}
 	counter=0;
}

/** delete @param filestodelete from current archive */
void CZip::removeFilesFromArchive( QStrList filestodelete ){
 	processread.clearArguments();
 	processread << "zip" << "-dq";
 	processread << archiveName;
  for (QString f = filestodelete.first(); f; f = filestodelete.next())
 	{
   	  processread << f;
	}
  processread.start(KProcess::Block);
}

/** Add some files to the archive
@param filestoadd : list of files to add
@param removeoriginalfiles : remove or not those files from disk
@param action : 0=mode append and replace files, 1=mode update files
@param relativepath : if !NULL, include only filenames, without their base path */
void CZip::addFilesToArchive( QStrList filestoadd, bool removeoriginalfiles, int action, const char* relativepath){
	QString s;

	if(relativepath!=NULL)
		QDir::setCurrent(relativepath);

	processread.clearArguments();
	processread << "zip";
	if(removeoriginalfiles)
		processread << "-m";
	if(recursivemode)
		processread << "-r";

  if(!archivePassword.isEmpty())
		processread  << "-P" << archivePassword;
  
	switch(action)
	{
		case 1:
			//Mode update
			processread << "-u";
			break;
	}

	processread << "-q";
	processread << archiveName;
	for (QString f = filestoadd.first(); f; f = filestoadd.next())
	{
	  s=f;
	  if(s.right(1)=="/")
	    s.truncate(s.length()-1);
	  if(s.find("file:")==0)
	    s.remove(0,5);
	  kdDebug()<<QString("AjArchZip:%1*in:%2*").arg(s).arg(archiveName)<<endl;
  	processread << s;
	}
	processread.start(KProcess::Block);
}

/** Create a zip archive
@param  nameofarchive: the name of the zip archive
@param param: list of files to add
@param relativepath: include only filenames, without their path */
void CZip::createArchive(QString nameofarchive, QStrList filestoadd, const char* relativepath) {
	QString str;

	archiveName=nameofarchive;
	kdDebug()<<QString("DebutCreationZip*%1*%2*").arg(nameofarchive).arg(relativepath)<<endl;
	addFilesToArchive(filestoadd, false, 0,relativepath);
	kdDebug()<<("\nFinCreationZip\n");
}

/** Returns true if archive type supports passwords */
bool CZip::supportPassword(){
 return true;
 
}
#include "czip.moc"
